////////////////////////////////
//                            //
//       FLEET 2000 BY        //
//      THE LETHMEISTER       //
//      MARK LETHBRIDGE       //
//   LETHMEISTER@EXCITE.COM   //
//   MULTIPLAYER VERSION!!!   //
//                            //
////////////////////////////////

unit MainScreen2;

interface

uses
 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
 ExtCtrls, ImgList, Math, StdCtrls, Gauges, ComCtrls, Buttons, jpeg,
  WSocket, WSocketS, TrayIcon, Menus, DXSounds;


type
  ShipRecord=record
   {Ship Performance}
   Acceleration,Velocity,StopDist,Angle,DestAngle,ActualX,ActualY,VelocityX,VelocityY,ExhaustX,ExhaustY:Real;
   EngineKind,Turn,MouseX,MouseY:Integer;
   {Weapons and Shield}
   LaserRecharge,ShieldRecharge,LaserValue,ShieldValue,LaserVelocity:Real;
   WeaponKind,SecondaryKind,Frags:Integer;
   LMouse,RMouse,AIPlayer:Boolean;
  end;

  PixPoint=^PixelRecord; {Pointer to PixelRecord}
  PixelRecord=record {On-screen pixel explosions and operations}
   x,y,velx,vely:real;
   Red,Green,Blue,FadeR,FadeG,FadeB,Time:integer;
   Next:PixPoint;
  end;

  WeaponRecord=record {Weapon information}
   x,y,velx,vely:Real;
   Enabled,Score:Boolean;
   Kind:Integer;
   Time:Integer;
   Owner:Integer
  end;

  MessageRecord=record {On-screen messages}
   MessageString:String[150];
   MessageColor:TColor;
   Time:integer;
  end;

  OrbiterRecord=record
   x,y,velx,vely,Angle,Radius:real;
   Health,OrbitSpeed:integer;
  end;

  TMainForm = class(TForm)
    GreyPlane: TImageList;
    MainTimer: TTimer;
    GameScreen: TPaintBox;
    GreenPlane: TImageList;
    StatusBar: TStatusBar;
    BackImage: TImage;
    ClientSocket: TWSocket;
    ServerSocket: TWSocket;
    OptionsPanel: TPanel;
    EnginePanel: TRadioGroup;
    PrimaryPanel: TRadioGroup;
    SecondaryPanel: TRadioGroup;
    GeneralPanel: TGroupBox;
    ShowPlayerInfo: TCheckBox;
    ShowAllianceInfo: TCheckBox;
    ShowMessages: TCheckBox;
    SelectAutopilot: TCheckBox;
    LChargePic: TImage;
    SChargePic: TImage;
    LevelMarksPic: TImage;
    GameMarksPic: TImage;
    NetBox: TGroupBox;
    ClientSelect: TSpeedButton;
    ServerSelect: TSpeedButton;
    HostEntry: TEdit;
    SelectAIBots: TUpDown;
    ShowAIBots: TLabel;
    BeginGameButton: TButton;
    CancelNewGame: TButton;
    ConnectButton: TSpeedButton;
    DisconnectButton: TSpeedButton;
    Bevel1: TBevel;
    QuitButton: TButton;
    TrayIcon: TTrayIcon;
    TrayMenu: TPopupMenu;
    AppRestore: TMenuItem;
    AppExit: TMenuItem;
    ShowGuages: TCheckBox;
    DXSound: TDXSound;
    DXWaveList: TDXWaveList;
    procedure MainTimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure GameScreenMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GameScreenMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GameScreenMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ConnectButtonClick(Sender: TObject);
    procedure DisconnectButtonClick(Sender: TObject);
    procedure ServerSelectClick(Sender: TObject);
    procedure ClientSelectClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SelectAIBotsClick(Sender: TObject; Button: TUDBtnType);
    procedure BeginGameButtonClick(Sender: TObject);
    procedure CancelNewGameClick(Sender: TObject);
    procedure SelectAutopilotClick(Sender: TObject);
    procedure PrimaryPanelClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure QuitButtonClick(Sender: TObject);
    procedure AppRestoreClick(Sender: TObject);
    procedure AppExitClick(Sender: TObject);
    procedure TrayIconDblClick(Sender: TObject);
    procedure SecondaryPanelClick(Sender: TObject);
    procedure EnginePanelClick(Sender: TObject);
    procedure DXSoundFinalize(Sender: TObject);
  private
  public   { Public declarations }
  end;

var
 MainForm: TMainForm;

 {Arrays}
  AllianceArray:array of array of integer;
  ShipArray:array of ShipRecord; {All Players over the net!}
  WeaponArray:array of WeaponRecord; {Dynamic array of Weapon projectiles}
  OrbiterArray:array of OrbiterRecord; {Dynamic array of Orbiter information}
  MessageArray:array of MessageRecord;
 {Game}
  BackRed,BackGreen,BackBlue:Integer; //Background Colours
  GamePicture:Tbitmap; // Picture held in memory
  BackPicture:Tbitmap;
  Audio:TAudioFileStream;
  Stream:TStream;
  PixelOp:Boolean;
  Head,Tail,Current:PixPoint; {Pixel Pointer variables}
  AssignedNumber:Integer;
  GameRunning,Paused:Boolean;

implementation

{$R *.DFM}

function GetColor(Red,Green,Blue:Integer):TColor;
{Converts RGB values into single colour}
begin
 GetColor:=red+(256*green)+(256*256*blue);
end; {GetColor}

procedure PixelExplode(Force,PixX,PixY:Real; PRed,PGreen,PBlue,Life:integer);
{Sets up pixels to explode in a random direction}
var Current:PixPoint;
    Angle:Real;
begin
 if not PixelOp then
 begin {Generate linked list}
  PixelOp:=True;
  new(Head);
  Current:=Head;
  Tail:=Head;
 end else
 begin {Add node to existing linked list}
  new(Current);
  Tail^.Next:=Current;
  Tail:=Current;
 end;
 Force:=Random*Force; {Create random force within a limit and a random angle (in radians)}
 Angle:=Random*2*pi;
 Current^.x:=PixX; {Set X and Y positions}
 Current^.y:=PixY;
 Current^.VelX:=Force*sin(Angle); {Set vector velocities using Angle and Force}
 Current^.VelY:=Force*cos(Angle);
 Current^.Time:=Life; {Set duration of pixel}
 Current^.Red:=PRed; {Set colour of pixel}
 Current^.Green:=PGreen;
 Current^.Blue:=PBlue;
 Current^.Next:=nil;  {Set to end linked list}
end; {PixelExplode}

procedure PixelOperations;
{Moves, removes and Displays Pixels}
var Current,Last:PixPoint;
begin
 Current:=Head; {Start at beginning of linked list}
 Last:=Head;
 repeat
  Current^.x:=Current^.x+Current^.velx;  {Increment X and Y positions}
  Current^.y:=Current^.y+Current^.vely;
  Current^.Time:=Current^.Time-1;
  GamePicture.Canvas.Pixels[round(Current^.X),round(Current^.Y)]:=GetColor(Current^.Red,Current^.Green,Current^.Blue);
  if Current^.Time<=0 then {Pixel Timeout}
  begin {Delete node}
   if Current=Head then if Head^.Next=nil then
   begin {Remove linked list}
    PixelOp:=False;
    Dispose(head);
   end {Remove linked list} else
   begin {Remove head}
    Head:=Head^.Next;
    Dispose(Current);
    Current:=Head;
   end {Remove head} else
   begin {Current<>Head}
    if Current^.Next<>nil then
    begin {Remove current node}
     Last^.Next:=Current^.Next;
     Dispose(Current);
     Current:=Last;
    end; {Remove current node}
   end; {Current<>Head}
  end; {Delete node}
 if PixelOp then if Current^.Next<>nil then
 begin {Move to next Pixel}
  Last:=Current;
  Current:=Current^.Next;
 end;
 until not PixelOp or (Current^.Next=nil); {Until linked list is removed or end is reached}
end;

procedure SoundOperations;
begin

end;

procedure FireWeapons(PosX,PosY,FireAngle,Separation:Real;WpnKind,LauncherID:integer);
var index,insert:integer;
begin
 if WpnKind in [0,2,3] then
 begin
  insert:=2;
  for index:=0 to Length(WeaponArray)-1 do
  if not (WeaponArray[index].Enabled) and (insert>0) then
  with WeaponArray[index] do
  begin
   Enabled:=true;
   X:=round(PosX+Separation*(sin(DegToRad(FireAngle+((((insert-1)*2)-1)*90)))*12));
   Y:=round(PosY+Separation*(-(cos(DegToRad(FireAngle+((((insert-1)*2)-1)*90)))*12)));
   VelX:=round(sin(DegToRad(FireAngle))*ShipArray[LauncherId].LaserVelocity);
   VelY:=round(-(cos(DegToRad(FireAngle))*ShipArray[LauncherId].LaserVelocity));
   Kind:=WpnKind;
   Time:=25;
   insert:=insert-1;
   Owner:=LauncherID;
  end;
  if insert>0 then
  begin {Increase Weapon Array Length}
   SetLength(WeaponArray,Length(WeaponArray)+insert);
   for index:=1 to insert do
   with WeaponArray[length(WeaponArray)-index] do
   begin
    Enabled:=True;
    X:=round(PosX+Separation*(sin(DegToRad(FireAngle+((((index-1)*2)-1)*-90)))*12));
    Y:=round(PosY+Separation*(-(cos(DegToRad(FireAngle+((((index-1)*2)-1)*-90)))*12)));
    VelX:=round(sin(DegToRad(FireAngle))*ShipArray[LauncherId].LaserVelocity);
    VelY:=round(-(cos(DegToRad(FireAngle))*ShipArray[LauncherId].LaserVelocity));
    Kind:=WpnKind;
    Time:=25;
    Owner:=LauncherID;
   end;
  end;
 end;
end;

procedure SmallOperations;
var index,subindex:integer;
begin
 index:=0;
 GamePicture.Canvas.Font.Color:=clYellow;
 if (Length(MessageArray)>=1) then
 repeat
  MessageArray[index].Time:=MessageArray[index].Time-1;
  if MessageArray[index].Time<=0 then
  begin
   if Length(MessageArray)>=2 then for subindex:=index to length(MessageArray)-2 do MessageArray[subindex]:=MessageArray[subindex+1];
   setlength(MessageArray,Length(MessageArray)-1);
  end;
  index:=index+1;
 until index>=Length(MessageArray);
 if MainForm.ShowMessages.Checked then for index:=0 to Length(MessageArray)-1 do GamePicture.Canvas.TextOut(5,5+Round(index*GamePicture.Canvas.TextHeight(MessageArray[index].MessageString)*1.3),MessageArray[index].MessageString);
 if MainForm.ShowGuages.Checked then
 begin
  GamePicture.Canvas.Pen.Color:=clBlue;
  {Laser}
  GamePicture.Canvas.Brush.Color:=clRed;
  GamePicture.Canvas.Rectangle(GamePicture.Width-70,110,GamePicture.Width-45,110-Round(ShipArray[AssignedNumber].LaserValue));
  GamePicture.Canvas.Draw(GamePicture.Width-70,120,MainForm.LChargePic.Picture.Graphic);
  {Shield}
  if ShipArray[AssignedNumber].ShieldValue>50 then GamePicture.Canvas.Brush.Color:=GetColor(255-round(5.1*(ShipArray[AssignedNumber].ShieldValue-50)),255,0)
  else GamePicture.Canvas.Brush.Color:=GetColor(255,round(5.1*(ShipArray[AssignedNumber].ShieldValue)),0);
  GamePicture.Canvas.Rectangle(GamePicture.Width-35,110,GamePicture.Width-10,110-Round(ShipArray[AssignedNumber].ShieldValue));
  GamePicture.Canvas.Draw(GamePicture.Width-35,120,MainForm.SChargePic.Picture.Graphic);
 end;
end;

procedure WeaponsOperations;
var index,ShipIndex,subindex:integer;
begin
 for index:=0 to Length(WeaponArray)-1 do
 with WeaponArray[index] do if Enabled then
 begin
  if Kind in [0,2,3] then
  begin
   x:=x+velx;
   if x>GamePicture.Width then x:=x-GamePicture.width;
   if x<0 then x:=x+GamePicture.Width;
   y:=y+vely;
   if y>GamePicture.Height then y:=y-GamePicture.Height;
   if y<0 then y:=y+GamePicture.Height;
   {Check hit on enemy}
   for ShipIndex:=0 to Length(ShipArray)-1 do with ShipArray[ShipIndex] do
   begin
    if (Power(X-ActualX,2)+Power(Y-ActualY,2)<400) and (ShipIndex<>Owner) then
    begin
     {Machine Gun}
     if Kind=0 then
     begin
      ShieldValue:=ShieldValue-5;
      for Subindex:=0 to Length(ShipArray)-1 do
      begin
       if AllianceArray[subindex,ShipIndex]<-15 then AllianceArray[subindex,owner]:=AllianceArray[subindex,owner]+2;
       if AllianceArray[subindex,ShipIndex]>15 then AllianceArray[subindex,owner]:=AllianceArray[subindex,owner]-2;
       if AllianceArray[subindex,Owner]<-30 then AllianceArray[subindex,Owner]:=-30 else
       if AllianceArray[subindex,Owner]>30 then AllianceArray[subindex,Owner]:=30;
      end;
      AllianceArray[ShipIndex,Owner]:=AllianceArray[ShipIndex,Owner]-5;
      if (AllianceArray[ShipIndex,Owner])<-30 then AllianceArray[ShipIndex,Owner]:=-30;
      if (ShipArray[ShipIndex].ShieldValue<=0) and (ShipArray[ShipIndex].ShieldValue+5>0) then
      begin
       MainForm.StatusBar.Panels[1].Text:='Player '+IntToStr(ShipIndex)+' was gunned down by Player '+IntToStr(Owner);
       SetLength(MessageArray,length(MessageArray)+1);
       MessageArray[Length(MessageArray)-1].MessageString:='Player '+IntToStr(ShipIndex)+' was gunned down by Player '+IntToStr(Owner);
       MessageArray[Length(MessageArray)-1].Time:=50;
       ShipArray[Owner].Frags:=ShipArray[Owner].Frags+1;
      end;
     end;
     
     if Kind=2 then
     begin
      AllianceArray[ShipIndex,Owner]:=AllianceArray[ShipIndex,Owner]+5;
      if AllianceArray[ShipIndex,Owner]>=30 then AllianceArray[ShipIndex,Owner]:=30;
     end;

     if Kind=3 then
     begin
      ShieldValue:=ShieldValue-20;
      for Subindex:=0 to Length(ShipArray)-1 do
      begin
       if AllianceArray[subindex,ShipIndex]<-15 then AllianceArray[subindex,owner]:=AllianceArray[subindex,owner]+8;
       if AllianceArray[subindex,ShipIndex]>15 then AllianceArray[subindex,owner]:=AllianceArray[subindex,owner]-8;
       if AllianceArray[subindex,Owner]<-30 then AllianceArray[subindex,Owner]:=-30 else
       if AllianceArray[subindex,Owner]>30 then AllianceArray[subindex,Owner]:=30;
      end;
      AllianceArray[ShipIndex,Owner]:=AllianceArray[ShipIndex,Owner]-15;
      if (AllianceArray[ShipIndex,Owner])<-30 then AllianceArray[ShipIndex,Owner]:=-30;
      if (ShipArray[ShipIndex].ShieldValue<=0) and (ShipArray[ShipIndex].ShieldValue+5>0) then
      begin
       MainForm.StatusBar.Panels[1].Text:='Player '+IntToStr(ShipIndex)+' was Rocketed by Player '+IntToStr(Owner);
       SetLength(MessageArray,length(MessageArray)+1);
       MessageArray[Length(MessageArray)-1].MessageString:='Player '+IntToStr(ShipIndex)+' was Rocketed by Player '+IntToStr(Owner);
       MessageArray[Length(MessageArray)-1].Time:=50;
       ShipArray[Owner].Frags:=ShipArray[Owner].Frags+1;
      end;
     end;

     for subindex:=0 to 10 do PixelExplode(10,X,Y,90,90,90,round(Random*50));
     Enabled:=False;
    end;
   end;
   Time:=time-1;
   if time<=0 then
   begin
    Enabled:=False;
    if Kind=3 then for subindex:=0 to 25 do PixelExplode(5,X,Y,255,255,0,Round(Random*40));
   end;
   GamePicture.Canvas.Pen.Color:=GetColor(BackRed+(Time*((255-BackRed) div 25)),BackGreen+(Time*((255-BackGreen) div 25)),BackBlue);
   if Kind=3 then GamePicture.Canvas.Pen.Color:=GetColor(0,0,255);
   GamePicture.Canvas.MoveTo(round(x),round(y));
   GamePicture.Canvas.LineTo(round(x-(velx/3)),round(y-(vely/3)));
   if Kind=3 then for subindex:=0 to 9 do
   begin
    PixelExplode(0.5,x-subindex*(VelX/10),y-subindex*(VelY/10),255,255,255,Round(Random*30));
   end;
  end;
 end;
end;

procedure ShipOperations;
var ShipIndex,index,subindex:integer;
    range,Gradient,Constant,EnRelX,EnRelY,RefX,RefY,TempAngle:real;
begin
 for ShipIndex:=0 to Length(ShipArray)-1 do with ShipArray[ShipIndex] do
 begin
  {==========CALCULATE MOVE==========}
  if (MouseX<>ActualX) and (MouseY<>ActualY) then Velocity:=Velocity+Acceleration;
  {Calculate stopping distance}
  index:=0;
  StopDist:=0;
  repeat
   StopDist:=StopDist+(Velocity-(index*Acceleration));
   index:=index+1;
  until Velocity-((index+1)*Acceleration)<=0;
  {Compare stopping distance with remaining distance}
  if Power(StopDist+Velocity-Acceleration,2)>=(Power(MouseX-ActualX,2))+(Power(MouseY-ActualY,2)) then
  begin {Slow down}
   if AIPlayer then
   begin
    MouseX:=round(Random*GamePicture.Width);
    MouseY:=round(Random*GamePicture.Height);
   end;
   if Velocity-2*Acceleration<0 then Velocity:=0
   else Velocity:=Velocity-2*Acceleration;
  end;
 {Calculate horizontal and vertical components}
  if not (RMouse and (SecondaryKind=0)) then
  begin
   VelocityX:=sin(DegToRad(Angle))*Velocity;
   VelocityY:=-(cos(DegToRad(Angle))*Velocity);
  end else
  begin
   if (ActualX+VelocityX<20) or (ActualX+VelocityX>GamePicture.Width-20) then VelocityX:=-VelocityX;
   if (ActualY+VelocityY<20) or (ActualY+VelocityY>GamePicture.Height-20) then VelocityY:=-VelocityY;
   VelocityX:=VelocityX*0.95;
   VelocityY:=VelocityY*0.95;
  end;
  {Move ship}
  ActualX:=ActualX+VelocityX;
  ActualY:=ActualY+VelocityY;
  {Calculate if docked}
  {Calculate angle between cursor and ship}
  if (MouseY>(ActualY)) then DestAngle:=180+RadToDeg(ArcTan((MouseX-(ActualX))/((ActualY)-MouseY))) else
  begin
   if (ActualY-MouseY)<>0 then DestAngle:=RadToDeg(ArcTan((MouseX-(ActualX))/((ActualY)-MouseY))) else MouseY:=MouseY+1;
   if DestAngle<0 then DestAngle:=DestAngle+360;
  end;
  {Turn ship towards angle}
  if (Abs(Angle-DestAngle)<Turn) or (Abs(Angle-DestAngle)>360-Turn) then Angle:=DestAngle;
  if angle<>DestAngle then
  begin
   if Angle<180 then if (DestAngle>Angle) and (DestAngle-Angle<180) then Angle:=Angle+Turn else Angle:=Angle-turn else
   if (DestAngle<Angle) and (Angle-DestAngle<180) then Angle:=Angle-Turn else Angle:=Angle+turn;
   if Angle<0 then Angle:=Angle+360;
   if Angle>360 then Angle:=Angle-360;
   if Velocity>=Acceleration+Acceleration/5 then Velocity:=Velocity-Acceleration-Acceleration/5 else velocity:=0;
  end;
  ExhaustX:=ActualX+20*sin((Angle+180)*(pi/180));
  ExhaustY:=ActualY-20*cos((Angle+180)*(pi/180));
  if ShieldValue<40 then
  begin
   for index:=0 to 15 do PixelExplode(1,ActualX,ActualY,round(5*ShieldValue),round(5*ShieldValue),round(5*ShieldValue),round(random*30));
   if random<0.08-(ShieldValue*0.002) then for index:=0 to 10 do PixelExplode(10,ActualX,ActualY,255,255,0,round(random*10));
  end;
  {=======END CALCULATE MOVE=========}

  {========CALCULATE SHOOT===========}
  if AIPlayer then
  begin
   TempAngle:=0;
   LMouse:=False;
   for index:=0 to Length(ShipArray)-1 do if (Index<>ShipIndex) then
   begin
    if (ShipArray[index].ActualY>ActualY) then TempAngle:=180+RadToDeg(ArcTan((ShipArray[index].ActualX-ActualX)/(ActualY-ShipArray[index].ActualY))) else
    if (ActualY-ShipArray[index].ActualY)<>0 then TempAngle:=RadToDeg(ArcTan((ShipArray[index].ActualX-(ActualX))/((ActualY)-ShipArray[index].ActualY)));
    if angle<>TempAngle then if (AllianceArray[ShipIndex,Index]<-15) and ((abs(Angle-TempAngle)<10) or ((abs(Angle-TempAngle)>350) and (abs(Angle-TempAngle)<360))) then LMouse:=True;
   end;
  end;
  {=======END CALCULATE SHOOT========}

  {========CALCULATE ENGINE==========}
  if EngineKind=0 then for index:=0 to 10 do PixelExplode(2,ExhaustX,ExhaustY,255,255,0,round(Random*10));
  if EngineKind=1 then
  for index:=0 to 4 do
  begin
   GamePicture.Canvas.Brush.Color:=clAqua;
   GamePicture.Canvas.Pen.Color:=clAqua;
   GamePicture.Canvas.Ellipse(round(ExhaustX-(5-index)-VelocityX*index/2),round(ExhaustY-(5-index)-VelocityY*index/2),round(ExhaustX+(5-index)-VelocityX*index/2),round(ExhaustY+(5-index)-VelocityY*index/2));
  end;
  {=======END CALCULATE ENGINE=======}


  {========CALCULATE WEAPONS=========}

  {Machine Guns, Alliance Gun}
  if LMouse and (LaserValue>5) and (WeaponKind in [0,2]) then
  begin
   FireWeapons(ActualX,ActualY,Angle,1.32,WeaponKind,ShipIndex);
   LaserValue:=LaserValue-5;
  end;

  {Rockets}
  if LMouse and (LaserValue>20) and (WeaponKind in [3]) then
  begin
   FireWeapons(ActualX,ActualY,Angle,0.5,WeaponKind,ShipIndex);
   LaserValue:=LaserValue-20;
  end;


  {Pulse Cannon}
  if (WeaponKind=1) and (LaserValue>20) and LMouse then
  begin
   LaserValue:=LaserValue-20;
   Range:=10;
   repeat {Draw beam pixels}
    PixelExplode(2,ActualX+(Range*Sin(Angle*(pi/180))),ActualY-(Range*Cos(Angle*(pi/180))),120,120,120,round(Random*30));
    Range:=Range+1;
   until Range>GamePicture.Width;
   Range:=GamePicture.Width;
   GamePicture.Canvas.Pen.Color:=clYellow; {Draw laser beam}
   GamePicture.Canvas.MoveTo(round(ActualX),round(ActualY));
   GamePicture.Canvas.LineTo(round(ActualX+Range*Sin(Angle*(pi/180))),round(ActualY-Range*cos(Angle*(pi/180))));
   Gradient:=Cotan(Angle*(pi/180));
   for index:=0 to Length(ShipArray)-1 do
   begin {Check enemies}
    EnRelX:=ShipArray[index].ActualX-ShipArray[ShipIndex].ActualX;
    EnRelY:=ShipArray[ShipIndex].ActualY-ShipArray[index].ActualY;
    Constant:=EnrelY+EnRelX*(1/Gradient);
    RefX:=(Constant*Gradient)/(Power(Gradient,2)+1);
    RefY:=Gradient*RefX;
    if power(RefX-EnRelX,2)+power(RefY-EnRelY,2)<400 then
    begin {Hit enemy}
     if (((Abs(Angle-90))<90) and (RefX>0)) or (((Abs(Angle-90))>90) and (RefX<0)) then
     begin {Ignore enemies behind ship}
      ShipArray[index].ShieldValue:=ShipArray[index].ShieldValue-15;
      for Subindex:=0 to Length(ShipArray)-1 do
      begin
       if AllianceArray[subindex,index]<-15 then AllianceArray[subindex,ShipIndex]:=AllianceArray[subindex,ShipIndex]+8;
       if AllianceArray[subindex,index]>15 then AllianceArray[subindex,ShipIndex]:=AllianceArray[subindex,ShipIndex]-8;
       if AllianceArray[subindex,ShipIndex]<-30 then AllianceArray[subindex,ShipIndex]:=-30 else
       if AllianceArray[subindex,ShipIndex]>30 then AllianceArray[subindex,ShipIndex]:=30;
      end;
      AllianceArray[index,ShipIndex]:=AllianceArray[index,ShipIndex]-20;
      if (AllianceArray[index,ShipIndex]<-30) then AllianceArray[index,ShipIndex]:=-30;
      for subindex:=0 to 10 do PixelExplode(5,ActualX+RefX,ActualY-RefY,0,250,0,round(random*40));
      if ShipArray[index].ShieldValue<=0 then
      begin

       SetLength(MessageArray,length(MessageArray)+1);
       MessageArray[Length(MessageArray)-1].MessageString:='Player '+IntToStr(index)+' was Pulse Cannoned by Player '+IntToStr(ShipIndex);
       MessageArray[Length(MessageArray)-1].Time:=50;

       MainForm.StatusBar.Panels[1].Text:='Player '+IntToStr(index)+' was Pulse Cannoned by Player '+IntToStr(ShipIndex);
       ShipArray[ShipIndex].Frags:=ShipArray[ShipIndex].Frags+1;
      end;
     end; {Ignore enemies behind Ship}
    end; {Hit enemy}
   end; {Check enemies}
  end;{Fire Pulse Cannon}

  if RMouse and (SecondaryKind=1) and (LaserValue>=15) then
  begin {Fire Cluster Bomb}
   for index:=1 to round(LaserValue) div 5 do
   begin
    FireWeapons(ActualX,ActualY,Angle+index*(360/(Round(LaserValue) div 5)),0.1,0,ShipIndex);
    for subindex:=0 to 10 do PixelExplode(20,ActualX,ActualY,255,255,0,Round(random*50));
   end;
   LaserValue:=round(LaserValue) mod 5;
  end; {Fire Cluster Bomb}
  if LaserValue<100 then LaserValue:=LaserValue+LaserRecharge else LaserValue:=100;
  if ShieldValue<100 then ShieldValue:=ShieldValue+ShieldRecharge else ShieldValue:=100;
  {=======END CALCULATE WEAPONS======}

  {=========CALCULATE DEATH==========}
  if ShieldValue<=0 then
  begin
   ShipArray[ShipIndex].frags:=ShipArray[ShipIndex].frags-1;
   for index:=0 to 300 do PixelExplode(40,ActualX,ActualY,Round(random*255),round(random*255),round(random*255),round(random*30)+30);
   ActualY:=0;
   ShieldValue:=100;
  end;
  {=======END CALCULATE DEATH========}

  {============DRAW SHIP=============}
  MainForm.GreyPlane.Draw(GamePicture.Canvas,Round(ActualX-20),Round(ActualY-20),round((Angle)/10));
  GamePicture.Canvas.Brush.style:=bsclear;
  GamePicture.Canvas.Font.Color:=clYellow;
  {Show Alliances}
  if MainForm.ShowAllianceInfo.Checked then for subindex:=ShipIndex to Length(ShipArray)-1 do
  begin

   if AllianceArray[subindex,ShipIndex]<-15 then GamePicture.Canvas.Pen.Color:=getcolor(255,255+(10*(AllianceArray[subindex,ShipIndex]+5)),255+(10*(AllianceArray[subindex,ShipIndex]+5))) else
   if AllianceArray[subindex,ShipIndex]>15 then GamePicture.Canvas.Pen.Color:=GetColor(255-(10*(AllianceArray[subindex,ShipIndex]-5)),255,255-(10*(AllianceArray[subindex,ShipIndex]-5))) else
   GamePicture.Canvas.Pen.Color:=clWhite;
   GamePicture.Canvas.MoveTo(Round(ShipArray[subindex].ActualX),Round(ShipArray[subindex].ActualY));
   if ShipArray[ShipIndex].AIPlayer then
   begin
    GamePicture.Canvas.LineTo((Round(ShipArray[ShipIndex].ActualX)+Round(ShipArray[subindex].ActualX)) div 2,(Round(ShipArray[ShipIndex].ActualY)+Round(ShipArray[subindex].ActualY)) div 2);
    if AllianceArray[ShipIndex,subindex]<-15 then GamePicture.Canvas.Pen.Color:=getcolor(255,255+(10*(AllianceArray[ShipIndex,subindex]+5)),255+(10*(AllianceArray[ShipIndex,subindex]+5))) else
    if AllianceArray[ShipIndex,subindex]>15 then GamePicture.Canvas.Pen.Color:=GetColor(255-(10*(AllianceArray[ShipIndex,subindex]-5)),255,255-(10*(AllianceArray[ShipIndex,subindex]-5))) else
    GamePicture.Canvas.Pen.Color:=clWhite;
   end;
   GamePicture.Canvas.LineTo(Round(ShipArray[ShipIndex].ActualX),Round(ShipArray[ShipIndex].ActualY));
  end;
  {End Show Alliances}
  if AllianceArray[ShipIndex,AssignedNumber]<-15 then GamePicture.Canvas.Font.Color:=clred else
  if AllianceArray[ShipIndex,AssignedNumber]>15 then GamePicture.Canvas.Font.Color:=cllime else GamePicture.Canvas.Font.Color:=clwhite;
  if ShipIndex=AssignedNumber then GamePicture.Canvas.Font.Color:=clblue;
  if MainForm.ShowPlayerInfo.Checked then GamePicture.Canvas.TextOut(Round(ActualX-20),Round(ActualY-35),IntToStr(ShipIndex)+': '+IntToStr(Frags) +' Frags')
  {===========END DRAW SHIP==========}
 end;
end;

procedure OrbiterOperations(DestX,DestY:Real);
var DestRange,DestAngle,TempDestX,TempDestY:real;
index,subindex:integer;
begin
 if Length(OrbiterArray)>0 then for index:=0 to Length(OrbiterArray)-1 do with OrbiterArray[index] do
 begin
  TempDestX:=DestX;
  TempDestY:=DestY;
  DestRange:=sqrt(power(X-TempDestX,2)+Power(Y-TempDestY,2));
  Angle:=Angle+(OrbitSpeed*(pi/180));
  if DestRange<=Radius*1.5 then
  begin
   TempDestX:=TempDestX+(Radius*sin(Angle));
   TempDestY:=TempDestY-(Radius*cos(Angle));
   VelX:=VelX*0.85;
   VelY:=VelY*0.85;
  end;
  DestAngle:=0;
  if (TempDestY>(Y)) then DestAngle:=ArcTan((TempDestX-(X))/((Y)-TempDestY))+pi else
  begin
   if Y-TempDestY<>0 then DestAngle:=ArcTan((TempDestX-(X))/((Y)-TempDestY));
   if DestAngle<0 then DestAngle:=DestAngle+2*pi;
  end;
  VelX:=VelX+(sin(DestAngle)*(DestRange/10));
  VelY:=VelY-(cos(DestAngle)*(DestRange/10));
  VelX:=VelX*0.95;
  VelY:=VelY*0.95;
  X:=X+VelX;
  Y:=Y+VelY;
  GamePicture.Canvas.Pen.Color:=clNavy;
  GamePicture.Canvas.Brush.Color:=clNavy;
  GamePicture.Canvas.Ellipse(round(X-4),round(Y-4),Round(X+4),Round(Y+4));
  for subindex:=0 to 20 do PixelExplode(1.5,X,Y,0,0,255,round(random*10));
 end;
end;

procedure TMainForm.MainTimerTimer(Sender: TObject);
begin
 if GameRunning and not paused then
 begin
  MainForm.GameScreen.Canvas.Draw(0,0,GamePicture);
  GamePicture.Canvas.Draw(0,0,BackPicture);
  OrbiterOperations(ShipArray[AssignedNumber].ActualX,ShipArray[AssignedNumber].ActualY);
  ShipOperations;
  WeaponsOperations;
  if PixelOp then PixelOperations;
  SmallOperations;
 end else
 begin
  if Paused and GameRunning then
  begin
   GamePicture.Canvas.Brush.Style:=bsClear;
   GamePicture.Canvas.Font.Color:=GetColor(Round(Random*255),Round(Random*255),Round(Random*255));
   GamePicture.Canvas.TextOut(1,1,'<< PAUSED >>');
  end else
  begin
   GamePicture.Canvas.Draw(0,0,BackPicture);
   if PixelOp then PixelOperations;
  end;
  GameScreen.Canvas.Draw(0,0,GamePicture);
 end;
end;

procedure NewGame;
var index,subindex:integer;
begin
 //Ship setup
 SetLength(ShipArray,MainForm.SelectAIBots.Position+1);
 SetLength(AllianceArray,Length(ShipArray),Length(ShipArray));
 for index:=0 to length(ShipArray)-1 do for subindex:=0 to length(ShipArray)-1 do AllianceArray[index,subindex]:=0;//round((random*60-30));

 AssignedNumber:=0;
 with ShipArray[AssignedNumber] do
 begin
  Angle:=180;
  StopDist:=0;
  acceleration:=1;
  ActualY:=0;
  ActualX:=AssignedNumber*(GamePicture.Width div (Length(ShipArray)))+(GamePicture.Width div (Length(ShipArray))) div 2;
  AIPlayer:=MainForm.SelectAutopilot.Checked;
  Turn:=15;
  LaserRecharge:=2;
  LaserVelocity:=25;
  ShieldRecharge:=0.2;
  LaserValue:=100;
  ShieldValue:=100;
  Frags:=0;
 end;
 for index:=0 to Length(ShipArray)-1 do with ShipArray[index] do
 if Index<>AssignedNumber then
 begin
  ShipArray[index]:=ShipArray[AssignedNumber];
  ActualY:=0;
  ActualX:=(index)*(GamePicture.Width div (Length(ShipArray)))+(GamePicture.Width div (Length(ShipArray))) div 2;
  Velocity:=0;
  RMouse:=False;
  LMouse:=False;
  AIPlayer:=True;
  repeat
   WeaponKind:=round(Random*(MainForm.PrimaryPanel.Items.Count-1));
  until WeaponKind<>2;
  EngineKind:=round(Random);
  MouseX:=round(Random*GamePicture.Width);
  MouseY:=round(Random*GamePicture.Height);
 end;
 SetLength(WeaponArray,1);
 SetLength(OrbiterArray,4);
//end ship setup
 for index:=0 to 3 do with orbiterArray[index] do
 begin
  Angle:=index*(pi/2);
  OrbitSpeed:=10;
  Radius:=40;
 end;
 {End set up ship}

end;


procedure TMainForm.FormActivate(Sender: TObject);
begin
 {Set up ship}
 MainForm.KeyPreview:=true;
 Randomize;
 SetLength(MessageArray,0);
 GameRunning:=False;
 GamePicture:=TBitmap.Create;
 GamePicture.Height:=GameScreen.Height;
 GamePicture.Width:=GameScreen.ClientWidth;
 GamePicture.TransparentColor:=clWhite;
 BackPicture:=TBitmap.Create;
 BackPicture.Width:=GameScreen.Width;
 BackPicture.Height:=GameScreen.Height;
 backPicture.Canvas.StretchDraw(rect(0,0,backpicture.width,backpicture.height),MainForm.BackImage.Picture.Graphic);
 NewGame;
 {Set up background}
 BackRed:=60;
 BackGreen:=75;
 BackBlue:=100;
 {Set up pixels}
 PixelOp:=False;
 New(Head);
 Tail:=Head;
 {Set up sound}
 try
  DXSound.Initialize;
  Audio:=TAudioFileStream.Create(DXSound.DSound);
  Audio.AutoUpdate := True;
  DXWaveList.Items.SaveToStream(Stream);
  Audio.WaveStream.CopyFrom(Stream,0);
  Audio.BufferLength := 1000;
  Audio.Looped := False;
 finally
 end;

end;

procedure TMainForm.GameScreenMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
 if not ShipArray[AssignedNumber].AIPlayer then
 begin
  ShipArray[AssignedNumber].MouseX:=x;
  ShipArray[AssignedNumber].MouseY:=y;
 end;
end;

procedure TMainForm.GameScreenMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if button=mbLeft then
 begin
  ShipArray[AssignedNumber].LMouse:=True;
 end;

 if button=mbRight then
 begin
  ShipArray[AssignedNumber].RMouse:=True;
 end;
end;

procedure TMainForm.GameScreenMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if button=mbLeft then
 begin
  ShipArray[AssignedNumber].LMouse:=False;
 end;
 if button=mbRight then
 begin
  ShipArray[AssignedNumber].RMouse:=False;
 end;
end;

procedure TMainForm.ConnectButtonClick(Sender: TObject);
begin
 NetBox.Hide;
 Statusbar.Panels[0].Text:='Connecting...';
end;

procedure TMainForm.DisconnectButtonClick(Sender: TObject);
begin
 NetBox.Show;
 Statusbar.Panels[0].Text:='Offline';
end;

procedure TMainForm.ServerSelectClick(Sender: TObject);
begin
 HostEntry.Text:='LOCAL: '+ClientSocket.LocalAddr;
 HostEntry.Enabled:=False;
end;

procedure TMainForm.ClientSelectClick(Sender: TObject);
begin
 HostEntry.Enabled:=True;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
 GamePicture.Width:=GameScreen.Width;
 GamePicture.Height:=GameScreen.Height;
 BackPicture.Width:=GameScreen.Width;
 BackPicture.Height:=GameScreen.Height;
 backPicture.Canvas.StretchDraw(rect(0,0,backpicture.width,backpicture.height),MainForm.BackImage.Picture.Graphic);
 GameScreen.Canvas.Draw(0,0,BackPicture);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Application.terminate;
end;

procedure TMainForm.SelectAIBotsClick(Sender: TObject; Button: TUDBtnType);
begin
 ShowAIBots.Caption:='Computer: '+IntToStr(SelectAIBots.Position);
end;

procedure TMainForm.BeginGameButtonClick(Sender: TObject);
begin
  OptionsPanel.Hide;
  NewGame;
  GameRunning:=True;
  Paused:=False;
end;

procedure TMainForm.CancelNewGameClick(Sender: TObject);
begin
 OptionsPanel.Hide;
end;

procedure TMainForm.SelectAutopilotClick(Sender: TObject);
begin
 ShipArray[AssignedNumber].AIPlayer:=SelectAutopilot.Checked;
end;

procedure TMainForm.PrimaryPanelClick(Sender: TObject);
begin
 ShipArray[AssignedNumber].WeaponKind:=PrimaryPanel.ItemIndex;
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key=49 then
 begin
  if PrimaryPanel.ItemIndex<PrimaryPanel.Items.Count-1 then PrimaryPanel.ItemIndex:=PrimaryPanel.ItemIndex+1 else PrimaryPanel.ItemIndex:=0;
  ShipArray[AssignedNumber].WeaponKind:=PrimaryPanel.ItemIndex;
 end;
 if Key=50 then
 begin
  if SecondaryPanel.ItemIndex<SecondaryPanel.Items.Count-1 then SecondaryPanel.ItemIndex:=SecondaryPanel.ItemIndex+1 else SecondaryPanel.ItemIndex:=0;
  ShipArray[AssignedNumber].SecondaryKind:=SecondaryPanel.ItemIndex;
 end;
 if Key=51 then
 begin
  if EnginePanel.ItemIndex<EnginePanel.Items.Count-1 then EnginePanel.ItemIndex:=EnginePanel.ItemIndex+1 else EnginePanel.ItemIndex:=0;
  ShipArray[AssignedNumber].EngineKind:=EnginePanel.ItemIndex;
 end;
 if Key=19 then paused:=not Paused;
 if Key=71 then ShowGuages.Checked:=not ShowGuages.Checked;
 if Key=80 then ShowPlayerInfo.Checked:=not ShowPlayerInfo.Checked;
 if Key=84 then
 begin
  StatusBar.visible:=not statusbar.visible;
  FormResize(MainForm);
 end;
 if Key=77 then ShowMessages.Checked:=not ShowMessages.Checked;
 if Key=76 then ShowAllianceInfo.Checked:=not ShowAllianceInfo.Checked;
 if Key=65 then
 begin
  SelectAutoPilot.Checked:=not selectAutoPilot.Checked;
  ShipArray[AssignedNumber].AIPlayer:=SelectAutoPilot.Checked;
 end;
 if (Key=88) and (ssAlt in Shift) then Application.Terminate;
 if key=66 then
 begin
  MainTimer.Enabled:=False;
  MainForm.Hide;
  TrayIcon.Show;
 end;

 if Key=32 then
 begin
  Paused:=not Paused;
  OptionsPanel.Left:=GameScreen.width div 2-OptionsPanel.Width div 2;
  OptionsPanel.Top:=GameScreen.Height div 2-OptionsPanel.Height div 2;
  OptionsPanel.visible:=paused;
 end;
 StatusBar.Panels[1].Text:=IntToStr(Key);
end;

procedure TMainForm.QuitButtonClick(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TMainForm.AppRestoreClick(Sender: TObject);
begin
 MainForm.Show;
 TrayIcon.Hide;
 MainTimer.Enabled:=True;
end;

procedure TMainForm.AppExitClick(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TMainForm.TrayIconDblClick(Sender: TObject);
begin
 AppRestoreClick(TrayIcon);
end;

procedure TMainForm.SecondaryPanelClick(Sender: TObject);
begin
 ShipArray[AssignedNumber].SecondaryKind:=SecondaryPanel.ItemIndex;
end;

procedure TMainForm.EnginePanelClick(Sender: TObject);
begin
 ShipArray[AssignedNumber].Enginekind:=EnginePanel.ItemIndex;
end;

procedure TMainForm.DXSoundFinalize(Sender: TObject);
begin
 Audio.Free;
 Audio:=nil;
end;

end.

